#Copyright 2006 DR0ID <dr0id@bluewin.ch> http://mypage.bluewin.ch/DR0ID
#
#
#
"""
#TODO: documentation!
"""

__author__ = "$Author: DR0ID $"
__version__= "$Revision: 35 $"
__date__   = "$Date: 2006-09-07 18:33:53 +0200 (Do, 07 Sep 2006) $"






class Action(object): #scene scripting
    
    def __init__(self, name):
        object.__init__(self)
        self.scene = None
        self.name = name
        
    def setname(self, obj, name):
        setattr(self, name, obj)
        
    def run(self, *args): #-> bool 0 ok, 1 use default
        print "action", self.name, "run()"

        # commands like
        # self.scene.wizard.head.doaction("losebeard")
        # self.scene.wizard.doaction("move", (dx, dy))
        

class Part(object):
    
    def __init__(self, name):
        object.__init__(self)
        self.name = name
        self.state = 0
##        self.pos = [0,0]
        self._wait = 0
        self.animation = None
        self.animations = {} # {name: anim}
        self.visible = 1
##        self.animname = ''
        
    def wait(self, sec=0):
        self._wait = sec*1000. #ms
        
    def move(self, dx, dy):
        for a in self.animations.values():
            a.rect.move_ip(dx, dy)
            a.pos = a.rect.center
##        self.pos[0] += dx
##        self.pos[1] += dy

    def update(self, dt):
##        print self.__class__, self.name, "update()"
        if self._wait>0:
            self._wait -= dt
            return 1
##        self.animation.play()
        if self.animation is not None:
            return self.animation.update(dt)
        else:
            return 0
    
    def draw(self, scr):
        if self.animation is not None:
            if self.visible:
                self.animation.draw(scr)
        
    def addAnim(self, name, anim):
        self.animations[name] = anim
        
    def show(self):
        self.visible = 1
        
    def hide(self):
        self.visible = 0
        
        
        




class Controller(object):
    
    def __init__(self, name):
        self.name = name
        self.actions = {} # {name:action}
        self.children = []
        self.actionqueue = []
        self.pos = [0,0]
      
    def addaction(self, action):
        self.actions[action.name] = action
        action.setname(self, self.name)
        
    def addObject(self, obj):
        setattr(self, obj.name, obj)
        self.children.append(obj)
        
    def removeObject(self, name):
        try:
            self.children.remove(getattr(self, name))
            delattr(self, name)
        except:
            pass
      
    def move(self, dx, dy):
        for child in self.children:
            child.move(dx, dy)
        self.pos[0] += dx
        self.pos[1] += dy
    
    def update(self, dt):
        # anim trigger here for anoyng animations
##        print self.__class__, self.name, "update()"
        res = 0
        for child in self.children:
            res = (res or child.update(dt))
            
        if res == 0 and len(self.actionqueue)>0:
            cmd = self.actionqueue.pop(0)
##            print self.name, "update get command", cmd, self.actionqueue, self.actions
            try:
                print self.name, "self.actions[cmd[0]]", self.actions[cmd[0]]
                self.actions[cmd[0]].run(cmd[1])
            except:
                #TODO default action
##                print self.name, "update default action"
                pass
##            self.actionqueue.pop(0)
        return res
        
        
    def draw(self, scr):
        for child in self.children:
            child.draw(scr)
            
            
    def doaction(self, spellname, *args):
        print self.name, "doaction", spellname
        self.actionqueue.append((spellname, args,))
##        try:
##            self.action = self.actions[spellname]
##        except:
##            # default action
##            print "default action"
##            return 0
##        if self.action.run():
##            #TODO should dpend on direction?
##            self.action = self.actions["default"]
    
 